//
// Created:     04.11.06
// Aurthor:    Iain Gilbert
//

#if defined _admin_commands_race_included
  #endinput
#endif

#define _admin_commands_race_included
#pragma library admin_commands_race
#include "base"
#include "utils\gtoutils"
#include "player"
#include "account"
#include "race"

new PlayerRaceEdit[MAX_PLAYERS]=INVALID_RACE_ID; // will hold id of race a player is currently creating
public AdminRaceCommandHandler(playerid,text[]) // process player commands
{
	if (!IsPlayerConnected(playerid)) return 0;
	if (!IsPlayerAdmin(playerid))
	{
    	PlayerRaceEdit[playerid]=INVALID_RACE_ID;
		return 0;
	}
	
	new cmd[20];
	new idx;
	set(cmd,strcharsplit(text, idx,strchar(" ")));

	if(strcomp(cmd, "/race", true) == 1)
	{
		set(cmd,strcharsplit(text, idx,strchar(" ")));
		if(strcomp(cmd, "create", true) == 1)
		{
			new racename[MAX_NAME];
			set(racename,text);
	        strdel(racename, 0, idx);
	        if (strlen(racename) <3)
			{
	   			SendPlayerFormattedText(playerid, "BAD RACE NAME: Race name must be at least 3 characters long.'", 0,COLOUR_RED);
				return 1;
			}
			if (strlen(racename) >40)
			{
	   			SendPlayerFormattedText(playerid, "BAD RACE NAME: Race name must be at most 40 characters long. Please choose a shorter name.'", 0,COLOUR_RED);
				return 1;
			}

			new tempname[MAX_STRING];
			set(tempname,racename);
			if (!StringCharCheck(tempname))
			{
				SendPlayerFormattedText(playerid, "BAD RACE NAME. Please use only a-z,0-9 characters in Race Name.", 0,COLOUR_RED);
				return 1;
			}

		    new raceid = RegisterRace(racename);
		    if (raceid == INVALID_RACE_ID)
		    {
		    	SendPlayerFormattedText(playerid, "Race Create Error. (race already exists?)", 0,COLOUR_RED);
				return 1;
			}

			// ok we good to go

			PlayerRaceEdit[playerid] = raceid;
			StartHeading[raceid] = 0.0;
			RaceSize[raceid] = 0;
			//StartHeading[raceid] = GetPlayerHeading(playerid);
			new Float:x, Float:y, Float:z;
			GetPlayerPos(playerid,x,y,z);
			AddRaceCP(raceid,x,y,z);
			SendPlayerFormattedText(playerid, "Race creation started.", 0,COLOUR_GREEN);
			SendPlayerFormattedText(playerid, "Your current position will be the startline of the race.", 0,COLOUR_MISC);
			SendPlayerFormattedText(playerid, "Use '/race cp' to add checkpoints. Use '/race cpremove' to remove the last checkpoint. ", 0,COLOUR_MISC);
			SendPlayerFormattedText(playerid, "Use '/race save' when done, to finalize race creation and initialize the race.", 0,COLOUR_MISC);
			SendPlayerFormattedText(playerid, " TODO: commands to change race settings. Just manualy edit db for now.", 0,COLOUR_MISC);
			
			return 1;
		}
		
		if(strcomp(cmd, "cp", true) == 1)
		{
			if (PlayerRaceEdit[playerid] == INVALID_RACE_ID)
			{
				SendPlayerFormattedText(playerid, "Error: You are not creating a race.", 0,COLOUR_RED);
				return 1;
			}
			new raceid = PlayerRaceEdit[playerid];
			if (Race[raceid][race_state] != RACE_STATE_DISABLED)
			{
		      	SendPlayerFormattedText(playerid, "Error: You cant modify that race.", 0,COLOUR_RED);
				return 1;
			}
			
			// ok, all good
			new Float:x, Float:y, Float:z;
			GetPlayerPos(playerid,x,y,z);
			AddRaceCP(raceid,x,y,z);
			SendPlayerFormattedText(playerid, "Checkpoint added.", 0,COLOUR_GREEN);
			return 1;
		}
		
		if(strcomp(cmd, "cpremove", true) == 1)
		{
			if (PlayerRaceEdit[playerid] == INVALID_RACE_ID)
			{
				SendPlayerFormattedText(playerid, "Error: You are not creating a race.", 0,COLOUR_RED);
				return 1;
			}
			new raceid = PlayerRaceEdit[playerid];
			if (Race[raceid][race_state] != RACE_STATE_DISABLED)
			{
		      	SendPlayerFormattedText(playerid, "Error: You cant modify that race.", 0,COLOUR_RED);
				return 1;
			}

			// ok, all good
			new Float:x, Float:y, Float:z;
			GetPlayerPos(playerid,x,y,z);
			RemoveLastRaceCP(raceid);
			SendPlayerFormattedText(playerid, "Checkpoint removed.", 0,COLOUR_GREEN);
   			return 1;
		}
		
		if(strcomp(cmd, "save", true) == 1)
		{
			if (PlayerRaceEdit[playerid] == INVALID_RACE_ID)
			{
				SendPlayerFormattedText(playerid, "Error: You are not creating a race.", 0,COLOUR_RED);
				return 1;
			}
			new raceid = PlayerRaceEdit[playerid];
			if (Race[raceid][race_state] != RACE_STATE_DISABLED)
			{
		      	SendPlayerFormattedText(playerid, "Error: You cant modify that race at this time.", 0,COLOUR_RED);
				return 1;
			}

			// ok, all good

			// set default values
 			Race[raceid][race_frequency] = 5;
 			Race[raceid][race_lineupdelay] = 45;
 			Race[raceid][race_minracers] = 1;
 			Race[raceid][race_minlevel] = 0;
 			Race[raceid][race_cashprize] = 2000;
			Race[raceid][race_cashentry] = 100;
			Race[raceid][race_xpprize] = 1000;
			Race[raceid][race_xpbonus] = 200;
			Race[raceid][race_maxracetime] = 300;
			CPSize[raceid] = 8;
			Race[raceid][race_state] = RACE_STATE_SLEEPING;
			RaceSaveBaseDB(raceid);
			PlayerRaceEdit[playerid] = INVALID_RACE_ID;
			RaceTimer[raceid] = 5;
			
			SendPlayerFormattedText(playerid, "Race created successfuly.", 0,COLOUR_GREEN);
			return 1;
		}
		
		if(strcomp(cmd, "start", true) == 1)
		{
		
			new raceid;
			raceid = strval(strcharsplit(text, idx,strchar(" ")));

			if ((raceid == 0) || (raceid >= MAX_RACES))
			{
				SendPlayerFormattedText(playerid,"Bad raceid.'", 0,COLOUR_RED);
				return 1;
			}
			if (Race[raceid][race_state] == RACE_STATE_DISABLED)
			{
				SendPlayerFormattedText(playerid,"Bad raceid.'", 0,COLOUR_RED);
				return 1;
			}
			if (Race[raceid][race_state] == RACE_STATE_RACING)
			{
				SendPlayerFormattedText(playerid,"That race is already in progress.", 0,COLOUR_RED);
				return 1;
			}
			if (Race[raceid][race_state] == RACE_STATE_LINEUP)
			{
				RaceTimer[raceid] = 0;
	        	StartRaceCountdown(raceid);
	        	return 1;
			}
			if (Race[raceid][race_state] == RACE_STATE_SLEEPING)
			{
				RaceTimer[raceid] = 0;
	        	StartRaceLineup(raceid);
	        	return 1;
			}
			return 1;
		}
	}
	return 0;
}

		
		
		

